#ifndef GIS_PROTO_H
#define GIS_PROTO_H

#define _BSD_SIGNALS
#include <signal.h>

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <bstring.h>

#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>

#undef DEBUG
#define CIV_MODE

#ifdef CIV_MODE
  #define GISapp "/project/K136/CIV/CIVGIS/Browser/tweety"
#else
  #define GISapp "tweety"
#endif

#define GIS_OFF 0
#define GIS_ON  1

#define TERRAIN 0
#define MAP     1
#define WEATHER 2

#define WALK    0
#define FLY     1

#define NHEAD   0
#define NURL    1
#define CAMP    2
#define CWALK   3
#define CFLY    4
#define CTER    5
#define CMAP    6
#define CWEA    7
#define SGIS    8
#define KGIS    9
#define CHGT   10
#define NOBJ   11
#define SREQ   32
#define SANS   33

#define URL_MAXLEN 255

extern int SOCK;


typedef float CamParams[7];

typedef struct GISproc_info
{
  pid_t pid;
  int sockfd;

  char stat;
  char cont;
  char orient;
};

inline int
readAll( register int fd, register void* buffer, register size_t len )
{
  register int st;
  
  do
    {
      st = read( fd, buffer, len );
#ifdef DEBUG
      fprintf( stderr, "readAll: len %d, st %d\n", len, st );
#endif
      if( st > 0 )
	{
	  len -= st;
	  buffer = ( char* )buffer + st;
	} 
      else
	{
	  if( st < 0 )
	    {
	      perror( "readAll" );
	      return -1;
	    }
	  return 0;
	}
    }
  while( len );
  return 1;
}

#endif /*GIS_PROTO_H*/
